//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on 2/22/2012.
//
#ifndef DNQSCONTAINER_H
#define DNQSCONTAINER_H

#include "TKContainer.h"

#include <QtScript/QScriptEngine>
#include <QtScript/QScriptValue>

class DNQSContainer : public TKContainer
{
public:
    DNQSContainer();
    virtual ~DNQSContainer();

    virtual TKCell*     createCellWithoutCellCodeClass(std::string theLocation, std::string theName, std::string type, std::string customScript);
    virtual TKCell*     createCellWithCellCodeClass(std::string theLocation, std::string theName, TKCellCode *cellCode, std::string customScript);
    virtual TKCellCode* createCellCode(std::string theName, std::string theAPIType, std::string code);

    virtual void    setValue(std::string key, float value);
    virtual float   getValue(std::string key);

    inline QScriptEngine*   getScriptEngine() { return mQSEngine; }
    inline QScriptValue     getScriptGlobalObject() { return mQSGlobalObject; }
    inline QScriptValue     getQSCellContainer() { return mQSCellContainer; }

    static const std::string CELLTYPE_JSBASIC;
    static const std::string CELLTYPE_OUT;
    static const std::string CELLTYPE_IN;
    static const std::string CELLTYPE_BASICSTORAGE;

 private:
    QScriptEngine   *mQSEngine;
    QScriptValue    mQSGlobalObject;
    QScriptValue    mQSCellContainer;
    TKCellCode      *mEmptyCellClass;
};

#endif // DNQSCONTAINER_H
