//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on Apr/15/2012.
//
#ifndef QTDNSERIALPORTIMPL_H
#define QTDNSERIALPORTIMPL_H

#include "DNSerialPortImpl.h"

#include "TKLock.h"

#include <serialport.h>
#include <QString>
#include <QQueue>
#include <QSemaphore>

class DNServerSerialPort;
class DNThread;

class QtDNSerialPortImpl : public DNSerialPortImpl
{
public:
    QtDNSerialPortImpl(DNServerSerialPort *server);
    virtual ~QtDNSerialPortImpl();

    virtual bool    setup();

    virtual bool    isRunning();
    virtual void    start();
    virtual void    stop();

    static void requestListenerThreadBody(void *impl);
    static void requestHandelrThreadBody(void *impl);

private:
    DNThread *mListnerThread;
    DNThread *mHandlerThread;
    SerialPort *mPort;
    bool    mStopping;

    QQueue<QString> mRequestQueue;
    TKLock          mLock;
    QSemaphore      mQueueSemaphore;
};

#endif // QTDNSERIALPORTIMPL_H
